package cn.estsh.i3plus.core.api.iservice.busi;

import cn.estsh.i3plus.pojo.platform.bean.Department;
import cn.estsh.i3plus.pojo.platform.bean.Organize;
import cn.estsh.i3plus.pojo.platform.bean.Position;
import cn.estsh.i3plus.pojo.platform.bean.SysMenu;

import java.util.List;

/**
 * @Description : 通用树查询服务
 * @Reference :
 * @Author : wei.peng
 * @Date : 2018-10-24 11:16
 * @Modify :
 **/
public interface ICoreTreeService {

    /**
     * 获取岗位树
     * @param parentId
     * @return
     */
    List<Position> findPositionTreeByParentId(long parentId);

    /**
     * 获取岗位树
     * @param id
     * @return
     */
    Position getPositionTreeByParentId(long id);

    /**
     * 生成子集树递归方法
     * @param parent 父类对象
     * @param step 层级
     */
    void findPositionChildrenTreePack(Position parent,int step);

    /**
     * 检查父节点是否是子节点ID或者为当前节点ID
     * @param position
     */
    void doValidatorPositionParentId(Position position) ;

    /**
     * 获取部门树
     * @param parentId
     * @return
     */
    List<Department> findDepartmentTreeByParentId(long parentId);

    /**
     * 获取部门树
     * @param id
     * @return
     */
    Department getDepartmentTreeByParentId(long id);

    /**
     * 生成子集树递归方法
     * @param parent 父类对象
     * @param step 层级
     */
    void findDepartmentChildrenTreePack(Department parent,int step);

    /**
     * 检查父节点是否是子节点ID或者为当前节点ID
     * @param department
     */
    void doValidatorDepartmentParentId(Department department) ;

    /**
     * 获取组织树
     * @param parentId
     * @return
     */
    List<Organize> findOrganizeTreeByParentId(long parentId);

    /**
     * 获取组织树
     * @param id
     * @return
     */
    Organize getOrganizeTreeByParentId(long id);

    /**
     * 生成子集树递归方法
     * @param parent 父类对象
     * @param step 层级
     */
    void findOrganizeChildrenTreePack(Organize parent,int step);

    /**
     * 检查父节点是否是子节点ID或者为当前节点ID
     * @param organize
     */
    void doValidatorOrganizeParentId(Organize organize) ;

    /**
     * 获取组织树
     * @param parentId
     * @return
     */
    List<SysMenu> findSysMenuTreeByParentId(long parentId);

    /**
     * 获取组织树
     * @param id
     * @return
     */
    SysMenu getSysMenuTreeByParentId(long id);

    /**
     * 生成子集树递归方法
     * @param parent 父类对象
     * @param step 层级
     */
    void findSysMenuChildrenTreePack(SysMenu parent, int step);

    /**
     * 检查父节点是否是子节点ID或者为当前节点ID
     * @param menu
     */
    void doValidatorSysMenuParentId(SysMenu menu) ;

}
