package cn.estsh.i3plus.core.api.iservice.busi;

import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.platform.bean.RefRoleMenu;
import cn.estsh.i3plus.pojo.platform.bean.SessionUser;
import cn.estsh.i3plus.pojo.platform.bean.SysMenu;
import cn.estsh.i3plus.pojo.platform.bean.SysRole;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * @Description : 系统角色业务接口 
 * @Reference   :
 * @Author      : wei.peng
 * @Date        : 2018-10-22 16:58:43.771
 * @Modify      :
 **/
public interface ISysRoleService {

    /**
     * 修改数据
     *
     * @param sysRole
     */
    void updateSysRole(SysRole sysRole);

    /**
     * 修改权限状态
     * @param id        修改权限状态
     * @param status    状态
     * @param user      当前用户会话
     * @return
     */
    void updateSysRoleStatus(String id, int status, SessionUser user);

    /**
     * 批量修改状态
     * @param ids
     * @param status
     * @param user
     */
    void updateSysRoleStatusByIds(String[] ids, int status, SessionUser user);

    /**
     * 根据Key 删除数据
     * @param id
     */
    void deleteSysRoleById(String id);

    /**
     * 根据id批量删除
     * @param ids id数组
     * @return
     */
    void deleteSysRoleByIds(String[] ids);

    /**
     * 新增数据
     *
     * @param sysRole
     * @return
     */
    SysRole insertSysRole(SysRole sysRole);

    /**
     * 刷新角色权限
     * @param roleId
     * @param ids
     */
    void refreshSysRoleRef(String roleId,String[] ids,SessionUser user);

    /**
     * 刷新角色权限
     * @param roleIds
     * @param ids
     */
    void refreshBatchSysRoleRef(String[] roleIds,String[] ids,SessionUser user);

    /**
     *
     * @param roleId
     * @return
     */
    List<RefRoleMenu> findRefRoleMenuByRoleId(String roleId);

    /**
     * 查询所有数据
     *
     * @return
     */
    List<SysRole> findSysRoleAll();

    /**
     * 根据id 数据
     *
     * @param id
     * @return
     */
    SysRole getSysRoleById(String id);

    /**
     * 复杂查询
     * @param role
     * @param pager
     * @return
     */
    ListPager<SysRole> querySysRole(SysRole role, Pager pager);
}
