package cn.estsh.i3plus.core.api.iservice.busi;

import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.platform.bean.SessionUser;
import cn.estsh.i3plus.pojo.platform.bean.SysFile;
import cn.estsh.i3plus.pojo.platform.bean.SysRole;
import cn.estsh.i3plus.pojo.platform.bean.TaskTimeExpression;

import java.util.List;

/**
 * @Description : 定时任务表达式业务接口
 * @Reference   :
 * @Author      : wei.peng
 * @Date        : 2018-10-22 16:58:43.771
 * @Modify      :
 **/
public interface ITaskTimeExpressionService {

    /**
     * 修改数据
     * @param taskTimeExpression
     */
    void updateTaskTimeExpression(TaskTimeExpression taskTimeExpression);

    /**
     * 根据Key 删除数据
     * @param id
     */
    void deleteTaskTimeExpressionById(String id);

    /**
     * 新增数据
     * @param taskTimeExpression
     * @return
     */
    TaskTimeExpression insertTaskTimeExpression(TaskTimeExpression taskTimeExpression);

    /**
     * 查询所有数据
     * @return
     */
    List<TaskTimeExpression> listTaskTimeExpression();

    /**
     * 根据ID 查询任务表达式
     * @param id
     * @return
     */
    TaskTimeExpression getTaskTimeExpressionById(String id);

    /**
     * 任务表达式查询，分页，排序
     * @param taskTimeExpression
     * @param pager
     * @return
     */
    ListPager queryTaskTimeExpressionByPager(TaskTimeExpression taskTimeExpression, Pager pager);

    /**
     * 任务表达式批量删除
     * @param ids
     */
    void deleteTaskTimeExpressionByIds(String[] ids);
}
