package cn.estsh.i3plus.core.api.iservice.busi;

import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.platform.bean.SessionUser;
import cn.estsh.i3plus.pojo.platform.bean.TaskTime;
import cn.estsh.i3plus.pojo.platform.bean.TaskTimeExpression;

import java.util.List;

/**
 * @Description : 定时任务业务接口
 * @Reference   :
 * @Author      : wei.peng
 * @Date        : 2018-10-22 16:58:43.968
 * @Modify      :
 **/
public interface ITaskTimeService {

    /**
     *  新增数据
     * @param taskTime
     * @return
     */
    TaskTime insertTaskTime(TaskTime taskTime, TaskTimeExpression taskTimeExpression);

    /**
     * 修改数据
     * @param taskTime
     */
    void updateTaskTime(TaskTime taskTime, TaskTimeExpression taskTimeExpression);

    /**
     * 修改任务状态
     * @param id        任务ID
     * @param status    任务状态
     * @param user      当前会话用户
     */
    void updateTaskTimeStatus(String id, int status, SessionUser user);

    /**
     * 根据Key 删除数据
     * @param id
     */
    void deleteTaskTimeById(String id);

    /**
     * 查询所有数据
     * @return
     */
    List<TaskTime> listTaskTime();

    /**
     * 根据id 数据
     * @param id
     * @return
     */
    TaskTime getTaskTimeById(String id);

    /**
     * 定时任务复制查询，分页，排序
     * @param taskTime
     * @param pager
     * @return
     */
    ListPager queryTaskTimeByPager(TaskTime taskTime, Pager pager);

    /**
     * 根据id批量删除定时任务
     * @param ids
     */
    void deleteTaskTimeByIds(String[] ids);

    /**
     * 批量修改定时任务状态
     * @param ids
     *
     */
    void updateTaskTimeStatusByIds(String[] ids, Integer status);

    /**
     * 修改最后时间
     * @param lastDate
     * @param name
     * @param groupName
     */
    void doTaskTimeLastDateByNameAndGroupName(String lastDate,String name,String groupName);

    /**
     * 立即执行
     * @param idStr
     */
    void executeTaskTimeById(long idStr);
}
